// importation des classes contenues dans le package mesh
// (dont notamment Delaunay, Voronoi…)
import megamu.mesh.*;

// déclarer un array multi-dim de positions
float[][] positions;
//PVector[] positions;
// déclarer un objet de type Delaunay
// c'est-à-dire qu'on dit que ça existe
Delaunay maillage;

void setup() {
  size(800,600);
  // affecter des valeurs à notre variable positions
  positions = new float[500][2]; // 500 positions avec chacune 2 coordonnées
  for (int i=0; i<positions.length; i++) {
    positions[i][0] = random(0, width); // remplir la première colonne de la ligne i
    positions[i][1] = random(0, height);
    //positions[i] = new PVector(random(0,width), random(0,height));
  }

  // affecter la valeur de l'objet Delaunay 
  // et calculer automatiquement la triangulation
  maillage = new Delaunay(positions);
}

void draw() {
  background(255);
  
  // faire évoluer la position d'index 0 selon la position
  // de la souris
  positions[0][0] = mouseX;
  positions[0][1] = mouseY;
  // mettre à jour mon calcul de maillage
  maillage = new Delaunay(positions);
  
  // dessiner les liens entre les points les plus proches
  // pour faire apparaître la triangulation
  float[][] segments = maillage.getEdges();
  for (int i=0; i<segments.length; i++){
    line(segments[i][0],segments[i][1],segments[i][2],segments[i][3]);
  }
  
  // dessiner mes noeuds en passant en revue chacune des lignes
  // de mon tableau de positions
  for (int i=0; i<positions.length; i++) {
    ellipse(positions[i][0],positions[i][1],5,5); 
  }
}

